package dev.fyloz.colorrecipesexplorer.service

import dev.fyloz.colorrecipesexplorer.model.RecipeStep
import dev.fyloz.colorrecipesexplorer.repository.RecipeStepRepository
import org.springframework.stereotype.Service

interface RecipeStepService : ModelService<RecipeStep, RecipeStepRepository> {

    /**
     *  Validates if the given [steps] obey the following criteria:
     *
     *      * The position of the steps is greater or equals to 1
     *      * Each position is unique in the collection
     *      * There is no gap between positions
     */
    fun validateStepsCollection(steps: Collection<RecipeStep>): Boolean
}

@Service
class RecipeStepServiceImpl(recipeStepRepository: RecipeStepRepository) :
    AbstractModelService<RecipeStep, RecipeStepRepository>(recipeStepRepository),
    RecipeStepService {
//    override fun validateStepsCollection(steps: Collection<RecipeStep>): Boolean {
//        val sortedSteps = steps.sortedBy { it.position }
//
//        fun validateStepPosition(step: RecipeStep) =
//            step.position >= 1
//
//    }
}
